"To eliminate the last of the old methods and block contexts do the following:
* Close any open file lists, browsers, message names etc.
* Close all Monticello browsers.
* Interrupt (Hit Cmd-Period or Alt-Period) to terminate the current Morphic process, then close the resulting notifier.
* Save and quit.
* Restart the image.
You shoud end up with only 1 unbound method below (the doit).  If you have more, Save and quit and try the doit again.  If unbound methods persist use e.g. 'chase pointers' in the explorer on a method to track down references.  If you get down to about three give up and try tracking down BlockContexts. Again Save and quit.  Then repeat these steps and use e.g. chase pointers to track down remaining references.   Cleanup is complete when there are no instances of BlockContext and no unbound methods other than the doit."

| unboundMethods contexts |
Smalltalk at: #ServiceRegistry ifPresent:[:cls| cls rebuild].
Smalltalk at: #UsefulScripts ifPresent:[:cls| cls cleanImage].
Smalltalk forgetDoIts.
Smalltalk garbageCollect.
unboundMethods := CompiledMethod allInstances select:[:m|
	m methodClass isNil or: [m ~~ (m methodClass compiledMethodAt: m selector ifAbsent: nil)]].
unboundMethods := unboundMethods copyWithout: thisContext method.
unboundMethods notEmpty ifTrue:
	[(ToolSet inspect: unboundMethods) setLabel: 'Unbound Methods'].
contexts := BlockContext allInstances.
contexts ifNotEmpty:[contexts inspect. self inform: 'There are left-over BlockContexts'].
(unboundMethods isEmpty and:[contexts isEmpty]) ifTrue:[
	self inform:'Congratulations - The bootstrap is now complete.'.
].